#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/socket.h>
#include <netdb.h>

char STRREQ[] = "GET / HTTP/1.1\nHost: t.karchnu.fr\n\n";

    int
main(int argc, char *argv[])
{
    struct addrinfo hints;
    struct addrinfo *result, *rp;
    int sfd, s;
    char buf[BUFSIZ];

    if (argc != 3) {
        fprintf(stderr, "Usage: %s ndd port\n", argv[0]);
        exit(EXIT_FAILURE);
    }

    memset(&hints, 0, sizeof(struct addrinfo));
    hints.ai_family = AF_UNSPEC;    /* Allow IPv4 or IPv6 */
    hints.ai_socktype = SOCK_STREAM; /* STREAM socket */
    hints.ai_flags = AI_PASSIVE;    /* For wildcard IP address */
    hints.ai_protocol = 0;          /* Any protocol */
    hints.ai_canonname = NULL;
    hints.ai_addr = NULL;
    hints.ai_next = NULL;

    s = getaddrinfo (argv[1], argv[2], &hints, &result);
    if (s != 0) {
        fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(s));
        exit(EXIT_FAILURE);
    }

    /* getaddrinfo() returns a list of address structures.
       Try each address until we successfully bind(2).
       If socket(2) (or bind(2)) fails, we (close the socket
       and) try the next address. */

    rp = result;
    sfd = socket(rp->ai_family, rp->ai_socktype, rp->ai_protocol);
    if (sfd == -1)
        exit (2);

    if (rp == NULL) {               /* No address succeeded */
        fprintf(stderr, "no DNS results\n");
        exit(EXIT_FAILURE);
    }

    printf("Trying to connect to the remote host\n");
    if(connect(sfd, (struct sockaddr *) rp->ai_addr, rp->ai_addrlen) == -1)
    {
        perror("connect");
        exit(EXIT_FAILURE);
    }

    freeaddrinfo(result);           /* No longer needed */

    printf("Connection OK\n");

    strncpy (buf, STRREQ, strlen (STRREQ));

    // send string
    if(send(sfd, buf, BUFSIZ, 0) == -1)
    {
        perror("send");
	close(sfd);
	exit(EXIT_FAILURE);
    }

    memset(buf, 0, BUFSIZ);

    // reception de la chaine de caracteres
    if(recv(sfd, buf, BUFSIZ, 0) == -1)
    {
        perror("recv");
        close(sfd);
        exit(EXIT_FAILURE);
    }

    buf[BUFSIZ-1] = '\0';

    printf ("REPONSE HTTP: \n%s", buf);
}
